/**
 * Couponer for Elementor
 * Discount Coupons Widget for Elementor Builder
 * Exclusively on https://1.envato.market/couponer-elementor
 *
 * @encoding        UTF-8
 * @version         1.1.5
 * @copyright       (C) 2018 - 2022 Merkulove ( https://merkulov.design/ ). All rights reserved.
 * @license         Envato License https://1.envato.market/KYbje
 * @contributors    Nemirovskiy Vitaliy (nemirovskiyvitaliy@gmail.com), Cherviakov Vlad (vladchervjakov@gmail.com)
 * @support         help@merkulov.design
 **/

/** Copy the coupon code to the clipboard. */
function copyCode(id){

    /** We get the item with the coupon code. */
    let text = document.getElementById( 'mdp-couponer-code-' + id );

    /** We inform the user that the coupon code has been copied. */
    let result = document.getElementById('mpd-result-' + id);

    /** Save the coupon code to the clipboard. */
    let range = document.createRange();
    range.selectNode(text);
    window.getSelection().addRange(range);

    /** Check if the coupon code was saved successfully. */
    try {
        let successful = document.execCommand( 'copy' );
        let msg = successful ? 'successful' : 'unsuccessful';
        result.innerHTML = "✓";
    } catch(err) {
        console.warning( 'Oops, unable to copy' );
    }

    /** Remove text selection. */
    window.getSelection().removeAllRanges();

}